import { Model, SDK, Response } from './common';

module Auth {

    export interface LoginParams {

        username: string;
        password: string;
    }

    interface LoginResponse extends Response { }

    export async function login(user: LoginParams): Promise<boolean> {
        try {
            let res = <LoginResponse>await SDK.getInstance().POST("auth/login", user);
            return res.success;
        } catch (err) {
            return false;
        }
    }

    export async function logout(): Promise<boolean> {
        try {
            let res = <LoginResponse>await SDK.getInstance().POST("auth/logout", {});
            return res.success;
        } catch (err) {
            return false;
        }
    }
}
export = Auth;
